use crate::runtime::Variable;
use crate::interface::{ allocate::*, builder::* };

pub struct List {
    managed:bool,
    addr:Variable,
}

impl List {
    pub fn new(t:u32) -> Self
    {
        let t = list(t);
        Self {
            managed:true,
            addr:Variable { class:t as usize, address: new(t) },
        }
    }

    pub fn capacity(&mut self) -> usize
    {
        let mem = if self.managed { address(self.addr.address) } else { self.addr };
        unsafe { list_capacity(mem) };
    }

    pub fn length(&mut self) -> usize
    {
        let mem = if self.managed { address(self.addr.address) } else { self.addr };
        unsafe { list_length(mem) };
    }

    pub fn at(&mut self, index:usize) -> Variable
    {
        let mem = if self.managed { address(self.addr.address) } else { self.addr };
        unsafe { list_at(mem, index) };
    }

    pub fn capacity(&mut self)
    {
        let mem = if self.managed { address(self.addr.address) } else { self.addr };
        unsafe { list_capacity(mem) };
    }
}

impl Drop for List {
    fn drop(&mut self) {
        if self.managed {
            delete(self.addr.address);
        }
    }
}
