use crate::runtime::{Variable, natural_get, natural_set};
use crate::interface::{ allocate::*, builder::* };

pub struct Natural {
    managed:bool,
    addr:Variable,
}

impl Natural {
    pub fn new() -> Self
    {
        let t = natural();
        Self {
            managed:true,
            addr:Variable { class:t as usize, address: new(t) },
        }
    }

    pub fn set(&mut self, value:u64)
    {
        let mem = if self.managed { address(self.addr.address) } else { self.addr };
        unsafe { natural_set(mem, value) };
    }

    pub fn get(&self) -> u64
    {
        let mem = if self.managed { address(self.addr.address) } else { self.addr };
        unsafe { natural_get(mem) }
    }
}

impl Drop for Natural {
    fn drop(&mut self) {
        if self.managed {
            delete(self.addr.address);
        }
    }
}
