#include <cstdint>
#include <cstdlib>

#include "type.h"
#include "typetree.h"
#include "nametree.h"
#include "pool.h"

#include "schema.h"

extern TypeTree DB_TYPE;
extern NameTree DB_NAME;
extern Pool<Variable> DB_DATA;

extern "C" uint32_t type_outer(uint32_t id, uint32_t key);
extern "C" uint32_t type_inner(uint32_t id);
extern "C" uint32_t type_key(uint32_t id);
extern "C" size_t type_size(uint32_t type_id);

void* allocate(uint32_t type_id, size_t count);
extern "C" size_t acquire(uint32_t type_id);
extern "C" bool release(size_t id);
extern "C" Variable address(size_t id);
extern "C" bool copy(Variable src, Variable dst);

// Boolean //
extern "C" void bool_set(Variable addr, Type::Boolean value);
extern "C" Type::Boolean bool_get(Variable addr);

// Natural //
extern "C" void natural_set(Variable addr, Type::Natural value);
extern "C" Type::Natural natural_get(Variable addr);

// Integer //
extern "C" void integer_set(Variable addr, Type::Integer value);
extern "C" Type::Integer integer_get(Variable addr);

// List //
extern "C" size_t list_capacity(Variable addr);
extern "C" size_t list_length(Variable addr);
extern "C" Variable list_first(Variable addr);
extern "C" Variable list_last(Variable addr);
void* list_cell(Variable addr, size_t index);
extern "C" Variable list_at(Variable addr, size_t index);
extern "C" void list_clear(Variable addr);
extern "C" void list_prepend(Variable addr, Variable source);
extern "C" void list_append(Variable addr, Variable source);
extern "C" void list_insert(Variable addr, size_t index, Variable source);
extern "C" void list_truncate(Variable addr, size_t maximum);
extern "C" void list_shift(Variable addr);
extern "C" void list_remove(Variable addr, size_t index, size_t maximum);
extern "C" void list_reserve(Variable addr, size_t capacity);
extern "C" void list_resize(Variable addr, size_t length);
